# Programming LLMs

This is the official repository for the examples built throughout Microsoft Press' book [Programming Large Language Models with Azure Open AI](https://www.microsoftpressstore.com/store/programming-large-language-models-with-azure-open-ai-9780138280376).

The three example projects cover various technologies and use cases:
1. Chapter 6 utilizes the OpenAI SDK and develops a web application (ASP.NET in .NET 8) that acts as an assistant, rewriting emails and messages produced by the technical team in response to tickets opened by end customers.
2. Chapter 7 explores the RAG (retrieval augmented generation) pattern by building a chatbot (in Streamlit and with Langchain) to ask questions and engage in conversations about loaded data, in the form of .pdf files.
3. Chapter 8 constructs an agent (using SemanticKernel and APIs built in WEB API with .NET 8) capable of conversational handling of hotel room reservations, via APIs documented with OpenAPI.




